<?php

/**
 * Register a custom help menu page.
 */
function kbxhd_add_help_menu_page(){

	$menu_slug = 'edit.php?post_type=kbx_knowledgebase';
	
	add_submenu_page(
        $menu_slug,
        __( 'Knowledgebase Help', 'kbx-qc' ),
        __( 'Help', 'kbx-qc' ),
        'manage_options',
        'kbx-help-kbhd-page',
        'kbxhd_add_help_page_callaback_func'
    );
	
}
add_action( 'admin_menu', 'kbxhd_add_help_menu_page' );
 
/**
 * Display help page content
 */
function kbxhd_add_help_page_callaback_func()
{
    
    ?>
	<div class="wrap">

        <div class="qcld-kbx-help-section">
            
    		<div id="icon-tools" class="icon32"></div>
        <h2 >Knowledgebase - Help</h2>

        <p>
            <strong>You need to use shortcodes to display article search page or glossary page. Copy the below shortcodes as per your requirement and put in your post or page.</strong>
        </p>

        <div class='qcld-kbx-section-block'>
            <h3 class="shortcode-section-title">
                Shortcodes:
            </h3>
            <p>
                <strong>[kbx-knowledgebase]: </strong> for article search page with category tiles.
            </p>
            <p>
                <strong>[kbx-knowledgebase-glossary]: </strong> for glossary page.
            </p>
        </div>

        <div class='qcld-kbx-section-block'>
            <h3 class="shortcode-section-title">
                Settings:
            </h3>
            <p>
                Settings options are self explanatory. These can be found under <strong>"Knowledgebase --> Settings"</strong>.
            </p>
        </div>

        <div class='qcld-kbx-section-block'>
            <h3 class="shortcode-section-title">
                Widgets:
            </h3>
            <p>
                Widgets can be found under <strong>"Appearence --> Widgets"</strong>.
            </p>
            <p>
                There are two avilable widgets. These are:
                <ol>
                    <li>Knowledgebase Articles <strong>[Sorting Options: Date, Popularity, Views]</strong></li>
                    <li>Knowledgebase Tag Cloud</li>
                </ol>
            </p>
        </div>

        <div class='qcld-kbx-section-block'>
            <h3 class="shortcode-section-title">
                Floating Search Widget:
            </h3>
            <p>You can enable this setting from the Bot Settings Page.
            </p>
        </div>

            <div class="qcld-kbx-section-block">
                <div>
                    <p>
                        <h3 class="shortcode-section-title"><?php _e('Custom Templating', 'kbx-qc'); ?>:</h3>
                    </p>
                    <p>
                        <?php _e('To design custom template for <strong>Archive</strong>,<strong>Articles Section</strong>,<strong> Article Search</strong>  & <strong>Article Detail</strong> page, you have to put <strong>kbhd</strong>  folder into your active theme root folder. Where', 'kbx-qc'); ?>
                    </p>
                    <ol>
                        <li> <strong>archive-kbx_knowledgebase.php</strong>  <?php _e('is for <strong>Archive</strong> page ', 'kbx-qc'); ?> </li>
                        <li> <strong>taxonomy-kbx_category.php</strong> <?php _e('is for <strong>Articles Section</strong> or <strong>Articles Category</strong>  page ', 'kbx-qc'); ?>  </li>
                        <li> <strong>search-kbx_knowledgebase.php</strong> <?php _e('is for <strong>Article Search</strong> page ', 'kbx-qc'); ?> </li>
                        <li> <strong>single-kbx_knowledgebase.php</strong> <?php _e(' is for <strong>Article Detail</strong> page ', 'kbx-qc'); ?> </li>
                    </ol>
                    <p><?php _e(' After placing template files into root directory of your active theme folder, now you can write custom style (CSS)  in your <strong>style.css</strong> file which will be implemented in Knowledgebase templates.', 'kbx-qc'); ?> </p>
                    <p><?php _e(' <strong>Warning : </strong> Don\'t rename <strong>kbhd</strong>  folder name.', 'kbx-qc'); ?> </p>
                </div>
            </div>

        </div>

    </div>
    <?php 
}
