<?php
/**
 * Plugin Name: Knowledgebase Helpdesk
 * Plugin URI: https://www.quantumcloud.com
 * Description: Advanced knowledgebase plugin with knowledgebase, helpdesk, glossary, ChatBot all in one.
 * Version: 3.2.1
 * Requires at least: 4.7
 * Tested up to: 5.3
 * Author: QuantumCloud
 * Author URI: https://www.quantumcloud.com
 * Text Domain: kbx-qc
 * License URI: https://www.quantumcloud.com
 * Domain Path: /languages
 */

// If this file is called directly, then abort execution.
if ( ! defined( 'WPINC' ) ) {
	die( "Aren't you supposed to come here via Administrator Access?" );
}


/**
 * Holds the URL for Knowledgebase-X
 *
 * @since	1.0
 *
 * @var string
 */

$kbx_url = plugins_url() . '/' . plugin_basename( dirname( __FILE__ ) );

//Custom Constants
if ( ! defined( 'KBX_VERSION' ) ) {
    define('KBX_VERSION', '1.0.0');
}
if ( ! defined( 'KBX_URL' ) ) {
	define('KBX_URL', plugin_dir_url(__FILE__));
}

if ( ! defined( 'KBX_ASSETS_URL' ) ) {
	define('KBX_ASSETS_URL', KBX_URL . "assets");
}

if ( ! defined( 'KBX_IMG_URL' ) ) {
    define('KBX_IMG_URL', KBX_ASSETS_URL . "/images");
}
if ( ! defined( 'KBX_DIR_ABS_PATH' ) ) {
define('KBX_DIR_ABS_PATH', plugin_dir_path(__FILE__));
}
if ( ! defined( 'KBX_IMG_ABS_PATH' ) ) {
    define('KBX_IMG_ABS_PATH', KBX_DIR_ABS_PATH . "assets/images");
}

if ( ! defined( 'KBX_DIR' ) ) {
	define('KBX_DIR', dirname(__FILE__));
}
if ( ! defined( 'KBX_PLUGIN_FILE' ) ) {
	define( 'KBX_PLUGIN_FILE', __FILE__ );
}

define('kbx_adv_bot_plugin_main_file', __FILE__);

/**
 * 
 * Declare $kbx_options global so that it can be accessed in every function
 *
 */

global $kbx_options;

$kbx_options = kbx_get_settings();

/**
 * 
 * Function to load translation files.
 *
 */

function kbx_lang_init() {
	load_plugin_textdomain( 'kbx-qc', false, dirname( plugin_basename( __FILE__ ) ) . '/languages' );

}

add_action( 'plugins_loaded', 'kbx_lang_init' );

/**
 * Get Settings.
 *
 * Retrieves all plugin settings
 * 
 * @return array wzkb settings
 */
function kbx_get_settings() {

	$settings = get_option( 'kbx_settings' );

	/**
	 * Settings array
	 *
	 * Retrieves all plugin settings
	 * 
	 * @param array $settings Settings array
	 */
	return apply_filters( 'wzkb_get_settings', $settings );
}


/*
 * ----------------------------------------------------------------------------*
 * Include files
 *----------------------------------------------------------------------------
 */

require_once( KBX_DIR . '/admin/kbx-register-settings.php' );
require_once( KBX_DIR . '/admin/kbx-shortcode-generator.php' );
require_once( KBX_DIR . '/includes/kbx-post-type.php' );
require_once( KBX_DIR . '/includes/kbx-add-post-meta.php' );
require_once( KBX_DIR . '/includes/kbx-shortcode.php' );
require_once( KBX_DIR . '/includes/kbx-ajax-search-question.php' );
require_once( KBX_DIR . '/includes/kbx-load-assets.php' );
require_once( KBX_DIR . '/includes/kbx-template-handling.php' );
require_once( KBX_DIR . '/includes/kbx-query.php' );
require_once( KBX_DIR . '/includes/kbx-utilities.php' );
require_once( KBX_DIR . '/includes/kbx-ajax-like-article.php' );
require_once( KBX_DIR . '/includes/kbx-widgets.php' );
require_once( KBX_DIR . '/includes/kbx-floating-search-widget.php' );
require_once( KBX_DIR . '/admin/kbx-articles-sections-ordering.php' );



if ( function_exists( 'register_block_type' ) ) {
	require_once( KBX_DIR . '/gutenberg/knowledgebase-blocks/plugin.php' );
}

require_once( 'kbx-help.php' );

//Support Page - Updated On - 06-01-2017
require_once('qc-support-promo-page/class-qc-support-promo-page.php');
require_once('qc-support-promo-page/class-qc-free-plugin-upgrade-notice.php');

/*
 ************************************************
 * Dashboard and Administrative Functionality
 ************************************************
 */
if ( is_admin() || ( defined( 'WP_CLI' ) && WP_CLI ) ) {

	/**
	 *  Load the admin pages if we're in the Admin.
	 */
	require_once( KBX_DIR . '/admin/kbx-admin.php' );
	require_once( KBX_DIR . '/admin/kbx-bot-admin.php' );
	require_once( KBX_DIR . '/admin/kbx-bot-admin-ui.php' );
	require_once( KBX_DIR . '/admin/kbx-settings-page.php' );
	require_once( KBX_DIR . '/admin/category/kbx_category_image.php');
	require_once( KBX_DIR . '/admin/kbx-save-settings.php' );
	//if(isset($_GET['taxonomy']) && $_GET['taxonomy']=='kbx_category'&& isset($_GET['post_type']) && $_GET['post_type']=='kbx_knowledgebase'){
        //require_once( KBX_DIR . '/admin/kbx-articles-sections-ordering.php' );
    //}


} // End admin.inc


/*******************************
 * Filter title to add Breadcrumb
 *******************************/
function kbx_modify_archive_query( $query ) 
{
	
	if( is_post_type_archive('kbx_knowledgebase') || is_tax( 'kbx_category' ) || is_tax( 'kbx_tag' ))
	{
		if( isset($_GET['sort']) &&  $_GET['sort'] != "" )
		{
			
			$sortBy = sanitize_text_field( $_GET['sort'] );

			if( isset($sortBy) && $sortBy == 'name' ){
				$orderby = 'title';
				$order   = 'ASC';
				$query->query_vars['order'] = $order;
			}

			if( isset($sortBy) && $sortBy == 'popularity' ){
				$orderby  = array( 'meta_value_num' => 'DESC' );
				$meta_key = 'kpm_upvotes';
				$query->query_vars['meta_key'] = $meta_key;
			}

			if( isset($sortBy) && $sortBy == 'views' ){
				$orderby  = array( 'meta_value_num' => 'DESC' );
				$meta_key = 'kpm_views';
				$query->query_vars['meta_key'] = $meta_key;
			}

			$query->query_vars['orderby'] = $orderby;
		}

	}

	return $query;
}

add_action( 'pre_get_posts', 'kbx_modify_archive_query' );

/**
 * Submenu filter function. Tested with Wordpress 4.7.3
 * Sort and order submenu positions to match your custom order.
 */

function kbx_order_index_menu_page( $menu_ord ) 
{

  global $submenu;

  // Enable the next line to see a specific menu and it's order positions
  //echo '<pre>'; print_r( $submenu['edit.php?post_type=kbx_knowledgebase'] ); echo '</pre>'; exit();

  $arr = array();

  $arr[] = $submenu['edit.php?post_type=kbx_knowledgebase'][5];
  $arr[] = $submenu['edit.php?post_type=kbx_knowledgebase'][10];
  $arr[] = $submenu['edit.php?post_type=kbx_knowledgebase'][15];
  $arr[] = $submenu['edit.php?post_type=kbx_knowledgebase'][16];
  $arr[] = $submenu['edit.php?post_type=kbx_knowledgebase'][24];
  $arr[] = $submenu['edit.php?post_type=kbx_knowledgebase'][25];
  // $arr[] = $submenu['edit.php?post_type=kbx_knowledgebase'][21];
  // $arr[] = $submenu['edit.php?post_type=kbx_knowledgebase'][22];
  $arr[] = $submenu['edit.php?post_type=kbx_knowledgebase'][17];
  $arr[] = $submenu['edit.php?post_type=kbx_knowledgebase'][26];

  
  if( isset($submenu['edit.php?post_type=kbx_knowledgebase'][300]) ){
    $arr[] = $submenu['edit.php?post_type=kbx_knowledgebase'][300];
  }
  $arr[] = $submenu['edit.php?post_type=kbx_knowledgebase'][23];

  $submenu['edit.php?post_type=kbx_knowledgebase'] = $arr;

  return $menu_ord;

}

// add the filter to wordpress
add_filter( 'custom_menu_order', 'kbx_order_index_menu_page' );


function qcld_kbx_support_page(){
	$instance_kbx0601a = new QcKBXSupportAndPromoPage('kbx-support');

	if( is_admin() )
	{
		$instance_kbx0601a->plugin_menu_slug = "edit.php?post_type=kbx_knowledgebase"; //Edit Value
		$instance_kbx0601a->plugin_name = "Knowledgebase Helpdesk - Free Version"; //Edit Value
		$instance_kbx0601a->show_promo_page();
	}
}
add_action('plugins_loaded', 'qcld_kbx_support_page');


//plugin activate redirect codecanyon
function qc_kbx_activation_redirect( $plugin ) {
    if( $plugin == plugin_basename( __FILE__ ) ) {
        exit( wp_redirect( admin_url('edit.php?post_type=kbx_knowledgebase&page=kbx-help-kbhd-page') ) );
    }
}
add_action( 'activated_plugin', 'qc_kbx_activation_redirect' );


//Adding upgrade to pro version notice
function kbx_upgrade_to_pro_notice() {
    $screen = get_current_screen();


    if ( is_admin() && ($screen->post_type == 'kbx_knowledgebase') ) {
        ?>
        <div class="notice notice-info is-dismissible woowbot-notice">
            <h4 style="text-align: center;"> The KB X Pro version is now available with Intelligent ChatBot Integrated with Google's DialogFlow, <a href="https://www.quantumcloud.com/products/knowledgebase-helpdesk/" target="_blank" style="text-decoration: none"> <strong style="color: orange">Upgrade to Pro</strong></a> </h4>
        </div>
        <?php
    }
}
add_action( 'admin_notices', 'kbx_upgrade_to_pro_notice',100 );

require_once( KBX_DIR . '/includes/kbx-activate-deactivate.php' );


register_activation_hook(  __FILE__, 'kbx_flush_rewrite_rules_on_plugin_activate' );
function kbx_flush_rewrite_rules_on_plugin_activate(){
    if ( ! get_option( 'kbx_flush_rewrite_rules_flag' ) ) {
        add_option( 'kbx_flush_rewrite_rules_flag', true );
    }
}

add_action( 'init', 'kbx_flush_rewrite_rules_maybe', 20 );

function kbx_flush_rewrite_rules_maybe() {
    if ( get_option( 'kbx_flush_rewrite_rules_flag' ) ) {
        flush_rewrite_rules();
        delete_option( 'kbx_flush_rewrite_rules_flag' );
    }
}